unit MyLib;

interface

function Upper(St: string): string;              {孨 ॣ (.)}
function Words(St: string; No: Integer): string;     {   No}
function MAlloc(Size: Word): Pointer;            {। }
function Within(X, Min, Max: Real): Boolean;     {. X  । ࠭}
function Space(Len: Byte): string;               {Len ஡}
procedure Stuff(var St:string; Index:Byte; Sub:string); {  Sub  St}
function RPad(St: string; Len: Byte): string;        { .ࠢ}
function RPadCh(St: string; Ch: Char; Len: Byte): string; { ᨬ}
function Rept(St: string; N: Byte): string;      { ப N ࠧ}
function Sign(X: Real): Integer;                 { 㬥}
function RTrim(St: string): string;              {ᥪ ࠢ}
function Value(St: string): Real;                {᫮  ८ࠧ}
function Trim(St: string): string;               {ᥪ ஡}
function LTrim(St: string): string;              {ᥪ ᫥}
function BiosKey(Cmd: Byte): Word;               {⥭  }
  { Cmd = 0; ⥭   塠⮢    ,
    Cmd = 1; ⥭   塠⮢    
             (  頥)
    Cmd = 2; । ﭨ -  ਣ  }

implementation

uses Dos;

function BiosKey(Cmd: Byte): Word;
var
  Reg: Registers;
begin
  Reg.AH := Cmd;
  Intr($16, Reg);
  case Cmd of
    0: BiosKey := Reg.AX;              {   }
    1: if Reg.Flags and fZero = fZero
         then BiosKey := 0             {   }
         else BiosKey := Reg.AX;       {   ( ⪨ ) }
    2: BiosKey := Reg.AL;              { $0040:$0017  Shift- }
  else BiosKey := 0;
  end;
end;

function LTrim(St: string): string;
begin
  while (St <> '') and (St[1] <= ' ') do Delete(St, 1, 1);
  LTrim := St;
end;

function RTrim(St: string): string;
begin
  while (St <> '') and (St[Length(St)] <= ' ') do Dec(St[0]);
  RTrim := St;
end;

function Trim(St: string): string;
begin Trim := LTrim(RTrim(St)) end;

function Value(St: string): Real;
var
  Figure: Real;
  Code: Integer;
begin
  Val(Trim(St), Figure, Code);
  if Code <> 0 then
    Value := 0.0
  else
    Value := Figure
end;

function Sign(X: Real): Integer;
begin
  if X > 0 then Sign := +1 else
    if X < 0 then Sign := -1 else
      Sign := 0;
end;

function Rept(St: string; N: Byte): string;
var
  Res: string;
begin
  Res := '';
  for N := 1 to N do Res := Res + St;
  Rept := Res;
end;

function RPadCh(St: string; Ch: Char; Len: Byte): string;
begin
  if Len > Length(St)
    then RPadCh:=St+Rept(Ch, Len-Length(St))
    else RPadCh:=St;
end;

function RPad(St: string; Len: Byte): string;
begin
  RPad := RPadCh(St, ' ', Len)
end;

procedure Stuff(var St: string; Index: Byte; Sub: string);
begin
  St := RPad(St, Index);
  Delete(St, Index, Length(Sub));
  Insert(Sub, St, Index);
end;

function Space(Len: Byte): string;
var S: string;
begin
  FillChar(S[1], Len, ' ');
  S[0] := Chr(Len);
  Space := S;
end;

function Within(X, Min, Max: Real): Boolean;
begin
  Within := (X >= Min) and (X <= Max)
end;

function MAlloc(Size: Word): Pointer;
var
  P: Pointer;
begin
  if Size < MaxAvail then
  begin
    GetMem(P, Size);
    FillChar(P^, Size, 0);
  end else
    P := nil;
  MAlloc := P;
end;

function Words(St: string; No: Integer): string;
const
  CharSet: set of Char = ['0'..'9', 'A'..'Z', '_', 'a'..'z',
                          ''..'', ''..'', ''..'', ''..''];
var
  I: Integer;
  V: string;
begin
  V := St;
  for I := 1 to No do
  begin
    while (V <> '') and not (V[1] in CharSet) do Delete(V, 1, 1);
    if I <> No then while (V <> '') and (V[1] in CharSet) do Delete(V, 1, 1);
  end;
  I := 1;
  if No > 0 then while (I <= Length(V)) and (V[I] in CharSet) do Inc(I);
  Words := Copy(V, 1, I - 1);
end;

function Upper(St: string): string;
var i: Byte;
begin
  for i := 1 to Length(St) do St[i] := UpCase(St[i]);
  Upper := St;
end;

end.